
\section{Examples of use of MaPHyS}

The is some driver that we provide to use some examples of maphys

\subsection{A matrix problem}

Those examples of \maphys are stored in the directory \emph{examples}.
There is the drivers using \maphys :

 \verb+<Arithms>_examplekv+ is a drivers that use input.in file.

Where \verb+<Arithms>+ is one of the different arithmetic that could be used.
\begin{itemize}
   \item \textbf{smph} for real arithmetic
   \item \textbf{dmph} for double precision arithmetic
   \item \textbf{cmph} for complex arithmetic
   \item \textbf{zmph} for complex double arithmetic
\end{itemize}

Only the test with the arithmetic you have choose during the compilation will be available.

You can see some examples of this files in the template available in the same directory \emph{examples} such as :

\begin{itemize}
   \item \textbf{real\_bcsstk17.in} is the input file to solve $A.x=b$ with A the bcsstk17 matrix (real, SPD, from Matrix Market),
     $b$ is stored in file, $x$ the solution should be the vector ones.
   \item \textbf{real\_bcsstk17\_noRHS.in} is the input file to solve $A.x=b$ with A the bcsstk17 matrix (real, SPD, from Matrix Market),
     $b$ generated such as solution $x$ is a pseudo random vector.
   \item \textbf{complex\_young1c.in} is the input file to solve $A.x=b$ with A the young1c matrix (complex,unsymmetric, from Matrix Market),
     $b$ generated such as solution $x$ is a pseudo random vector.
\end{itemize}

In order to launch these tests, you need to use the command :

\begin{verbatim}
mpirun -np <nbproc> ./<Arithms>_examplekv <ExampleFile>
\end{verbatim}

Where \verb+ExampleFile+ is a string that contains the link to the input file you want to use and \verb+<nbproc>+ the number of processus you want to use. 


For example you can use the following command :

\begin{verbatim}
mpirun -np 4 ./smph_examplekv real_bcsstk17.in
\end{verbatim}


 \*\textbf{Warning: Make sure that $<$nbproc$>$ is a power of two because maphys is based on dissection method. }

\subsubsection{How to write an input file}

The input.in file are file in free format. An example can be found in \verb+template.in+.
It should be written as follow.


All lines begining with \verb?#? are a comment line. \\
Empty lines are possible. \\
Setting parameter is based on key/value in the following format : \\
\verb+KEY = VALUE+
 

\subsubsection{System description}

\begin{itemize}
\item Key: \verb+MATFILE+ \\
  Fields: \verb+[I,J,V,N,NNZ]+ \\
  Type: \verb?string? \\
  Description: Path to the matrix file
  Constrains: supported file extension are:
  \begin{itemize}
  \item .mtx or .mm (Matrix Market)
  \item .ijv        (coordinate format)
  \item .rsa        (Harwell Boeing) \\
  \end{itemize} 

\item Key: \verb+SYM+ \\
  Fields: \verb+[SYM]+ \\
  Type: \verb?Integer(kind=4)? \\
  Description: Specifies the matrix symmetry, if given, it supperseed the
  symmertry read in "MATFILE". \\
  Constrains: supported value are:
  \begin{itemize}
  \item 0 (General)
  \item 1 (SPD)
  \item 2 (symmetric) \\
  \end{itemize} 

\item Key: \verb+RHSFILE+ \\
  Fields: \verb+[RHS]+ \\
  Type: \verb?string? \\
  Description: Path to the file containing the right-hand-side. \\
  Constrains: supported file extension are:
  \begin{itemize}
  \item .ijv        (coordinate format) 
  \end{itemize}
  Note 1:  If file is invalid, or not set,
  the right-hand-side is generated from a pseudo random solution \\

\item Key: \verb+INITGUESSFILE+ \\
  Fields: \verb+[SOL]+ \\
  Type: \verb?string? \\
  Description: Path to the file containing the initial guess. \\
  Constrains: supported file extension are:
  \begin{itemize}
  \item .ijv        (coordinate format)
  \end{itemize}
  Note 1:  User must also set \ref{itm:icntl23} to 1 to activate this option \\
  Note 2:  If not set, initial guess is vector Null  \\

\item Key: \verb+OUTRHSFILE+ \\
  Fields: \verb+[RHS]+ \\
  Type: \verb?string? \\
  Description: Path to the file where to write the rhs. \\
  Constrains: must be non empty, writtent only by process 0. \\

\item Key: \verb+OUTSOLFILE+ \\
  Fields: \verb+[SOL]+ \\
  Type: \verb?string? \\
  Description: Path to the file where to write the solution. \\
  Constrains: must be non empty, writtent only by process 0. \\
\end{itemize}

\subsubsection{System description}

\begin{itemize}
\item Key: \verb?JOB?  \\
  Fields: \verb?[JOB]? \\
  Type: \verb?Integer(kind=4)? \\
  Description: set the job to perform \\
  Contraints: are those of JOB. \\

\item  Key: \verb?ICNTL([0-9]+)? \\ 
  Fields: \verb?[ICNTL([0-9]+)]? \\
  Type: \verb?Integer(kind=4)? \\
  Description: set an ICNTL parameter \\
  Contraints: are those of ICNTL. \\

\item Key:\verb?RCNTL([0-9]+)? \\
  Fields: \verb?[RCNTL([0-9]+)]? \\
  Type: \verb?Real(kind=8)? \\
  Description: set an RCNTL parameter \\
  Contraints: are those of RCNTL. \\

\end{itemize}

\emph{Note : For more details on possible value for ICNTL and RCNTL, you may refer to Section \ref{sec:controlpar}}


\subsection{A cube generation problem}

An other example that we provide is a cubes generations problem that you can have using the command line :

\begin{verbatim}
make testdistsys
\end{verbatim}

Those examples of \maphys are stored in the directory \emph{examples}.
There is the drivers using \maphys :

 \verb+<Arithms>_testdistsys+ is a drivers that use input.in file.

Where \verb+<Arithms>+ is one of the different arithmetic that could be used.
\begin{itemize}
   \item \textbf{smph} for real arithmetic
   \item \textbf{dmph} for double precision arithmetic
   \item \textbf{cmph} for complex arithmetic
   \item \textbf{zmph} for complex double arithmetic
\end{itemize}

Only the test with the arithmetic you have choose during the compilation will be available.


In order to launch these tests, you need to use the command :

\begin{verbatim}
mpirun -np <nbproc> ./<Arithms>_testdistsys <CubeFile> <InputFile>
\end{verbatim}



Where \verb+CubeFile+ is a string that contains the link to the cube description file you want to use and \verb+InputFile+ is a string that contains the link to the input file you want to use and \verb+<nbproc>+ the number of processus you want to use. 


For example you can use the following command :

\begin{verbatim}
mpirun -np 4 ./smph_testdistsys cube.in dmph.in
\end{verbatim}


 \*\textbf{Warning: Make sure that $<$nbproc$>$ is a power of two because maphys is based on dissection method. }

The \verb+InputFile+ is a file that is describe as in section xxx

The \verb+CubeFile+ is a file that is describe as follow :

\begin{verbatim}
10  # size_x
10  # size_y
10  # size_z
0   # problem
0   # an
0.d0 # p1
0.d0 # p2
\end{verbatim}

Where \verb+size_x+, \verb+size_y+ and \verb+size_z+ are the cube dimensions.

\verb+problem+ is ..

\verb+an+ is ..
 
\verb+p1+ and \verb+p2+ are..

\subsection{How to use \maphys{} in an other code}

\subsubsection{Fortran example}

Here is a fortran example of a driver using \maphys :

\lstinputlisting[language=Fortran, firstnumber=1]{example_f.F90}

\subsubsection{C example}

Here is a C example of a driver using \maphys :

\lstinputlisting[language=C, firstnumber=1]{example_c.c}
